#!/usr/bin/perl

# $Id: morgdkp.pl,v 1.11 2006/07/10 18:49:35 dmitry Exp $

use LWP::Simple;
### Try this alternate file if your DKP is not correct 

##########################################################################################################################################
###																																		##
### To add a raid for DKP tracking simply insert the link for the correct DKP#  ie. if your raids are named MC1, MC2 in that order 		##
### MorgDKP will tell you which raid should be DKP1.																					##
### Example MorgDKP output: MC1 = DKP1																									##
###			    MC2 = DKP2																												##
###			    BWL = DKP3																												##
### So you would change the link for DKP1 to the url for your MC1 data, DKP2 link would be MC2 data, etc								##
### Note: You also need to uncomment the lines for each raid ie. remove the ### before DKP2 etc					        				##
### You can track a max of 5 raids:)																									##
###																																		##
##########################################################################################################################################
	
@pages = (
	{ title => "DKP1",		url => 'http://sodalityoftheconstant.com/mcdkp/listmembers.php?show=all' },
###	{ title => "DKP2",		url => 'http://sodalityoftheconstant.com/eqdkp/listmembers.php?show=all' },
###	{ title => "DKP3",		url => 'http://sodalityoftheconstant.com/bwldkp/listmembers.php?show=all' },
###	{ title => "DKP4",		url => 'http://sodalityoftheconstant.com/aqdkp/listmembers.php?show=all' },
###	{ title => "DKP5",		url => 'http://sodalityoftheconstant.com/bwldkp/listmembers.php?show=all' },
);

$|=1;
$i=0;
open F,">DKPInfo.lua";
foreach $pg (@pages) {
	$title=${$pg}{title};
	$url=${$pg}{url};
	print "Retriving ".(++$i).".$title \[$url\]...";
	if($page=get($url)) {
		$j=1;
		undef @table;
		print "OK\n";
		print "Parsing...";
		$page=~s/^.+<form method=\"post\" action=\"listmembers.php\?s=[^<]+<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">//s;
		$page=~s/^.+?<tr>.+?<\/tr>//s;
		$page=~s/^.+?<tr>.+?<\/tr>//s;
		while($page=~/<tr.*?>.*?<td.*?>.+?<\/td>.*?<td.*?>.+?<\/td>.*?<td.*?><a.*?>(.+?)<\/a><\/td>.*?<td.*?>(.+?)<\/td>.*?<td.*?>(.+?)<\/td>.*?<td.*?>(.+?)<\/td>.*?<td.*?>(.+?)<\/td>.*?<td.*?>.+?<\/td>.*?<td.*?>(.+?)<\/td>.*?<td.*?>.+?<\/td>.*?<td.*?>.+?<\/td>.*?<\/tr>/sg) {
	    	($nick,$rank,$class,$earned,$spent,$value)=($1,$2,$3,$4,$5,$6);
		    $nick=~s/<.*?>//g;
		    $nick=~s/ \(.+?\)//;		### for alternate DKP format name (o)
		    $nick=~s//\\195\\162/g;
			$nick=~s//\\194\\161/g;
			$nick=~s//\\194\\170/g;
			$nick=~s//\\194\\186/g;
			$nick=~s//\\194\\191/g;
			$nick=~s//\\195\\128/g;
			$nick=~s//\\195\\129/g;
			$nick=~s//\\195\\130/g;
			$nick=~s//\\195\\131/g;
			$nick=~s//\\195\\133/g;
			$nick=~s//\\195\\135/g;
			$nick=~s//\\195\\136/g;
			$nick=~s//\\195\\137/g;
			$nick=~s//\\195\\138/g;
			$nick=~s//\\195\\139/g;
			$nick=~s//\\195\\140/g;
			$nick=~s//\\195\\141/g;
			$nick=~s//\\195\\142/g;
			$nick=~s//\\195\\143/g;
			$nick=~s//\\195\\144/g;
			$nick=~s//\\195\\145/g;
			$nick=~s//\\195\\146/g;
			$nick=~s//\\195\\147/g;
			$nick=~s//\\195\\148/g;
			$nick=~s//\\195\\149/g;
			$nick=~s//\\195\\152/g;
			$nick=~s//\\195\\153/g;
			$nick=~s//\\195\\154/g;
			$nick=~s//\\195\\155/g;
			$nick=~s//\\195\\157/g;
			$nick=~s//\\195\\160/g;
			$nick=~s//\\195\\161/g;
			$nick=~s//\\195\\163/g;
			$nick=~s//\\195\\165/g;
			$nick=~s//\\195\\167/g;
			$nick=~s//\\195\\168/g;
			$nick=~s//\\195\\169/g;
			$nick=~s//\\195\\170/g;
			$nick=~s//\\195\\171/g;
			$nick=~s//\\195\\172/g;
			$nick=~s//\\195\\173/g;
			$nick=~s//\\195\\174/g;
			$nick=~s//\\195\\175/g;
			$nick=~s//\\195\\176/g;
			$nick=~s//\\195\\177/g;
			$nick=~s//\\195\\178/g;
			$nick=~s//\\195\\179/g;
			$nick=~s//\\195\\180/g;
			$nick=~s//\\195\\181/g;
			$nick=~s//\\195\\184/g;
			$nick=~s//\\195\\185/g;
			$nick=~s//\\195\\186/g;
			$nick=~s//\\195\\187/g;
			$nick=~s//\\195\\189/g;
			$nick=~s//\\195\\191/g;
			$nick=~s//\\195\\132/g;
			$nick=~s//\\195\\134/g;
			$nick=~s//\\195\\150/g;
			$nick=~s//\\195\\156/g;
			$nick=~s//\\195\\158/g;
			$nick=~s//\\195\\159/g;
			$nick=~s//\\195\\164/g;
			$nick=~s//\\195\\166/g;
			$nick=~s//\\195\\182/g;
			$nick=~s//\\195\\188/g;
			$nick=~s//\\195\\190/g;
			$class=lc($class);
		    $rank=~s/<.*?>//g;
		    $rank='' if $rank eq '&nbsp;';
	    	push @table,"[\"$nick\"] = {earn = $earned,spent = $spent,bal = $value}" if length $earned < 10;
			print $j++."..";
		}
		$j--;
		print "Done.\n\n";
		print F "$title = {\n\t";
		print F "Timestamp = 000000,\n\t";
		print F "Points = {\n\t\t";
		print F join(",\n\t\t",@table);
		print F "\n\t},\n}\n";
		
	} else {
		print "hren\n";
	}
}
close F;


