local L = AceLibrary("AceLocale-2.2"):new("MorgDKP")

L:RegisterTranslations("enUS", function() return {
	cmd1 = "/dkp",
	cmd2 = "/MorgDKP",
		
	horde = "Horde",
	morgtitle = "MorgDKP",
	scan = "Scan raid",
	scandesc = "Scan the raid for current equipment and members.",
	morgbidcheck = "MorgBid Base",
	morgbidcheckdesc = "Determine MorgBid user base. \nAlso useful to check DKP for alts.",
	dkp = "DKP Functions",
	dkpdesc = "Functions related to tracking DKP.",
	startraid = "Start Raid",
	startraiddesc = "Reset the raid database to begin tracking a new raid.  \nAlso outputs DKP string for start bonus.",
	endraid = "End Raid",
	endraiddesc = "Close the raid database and output the DKP string for bosses killed and loot received.",
	adddkp = "Add DKP",
	adddkpdesc = "Add DKP to a raid member. \nFormat: <charname> <points>",
	subdkp = "Remove DKP",
	subdkpdesc = "Remove DKP from a raid member. \nFormat: <charname> <points>",
	rundkp = "Output attendees",
	rundkpdesc = "Output parse string for raid attendees. (Run DKP bonus)",
	queryraid = "Query Raid",
	queryraiddesc = "Query raid members interest in the given item.",
	setitempoints = "Set Item Points",
	setitempointsdesc = "DKP charge for selected item.",
	logquality = "Log Quality",
	logqualitydesc = "Anything below this quality level will NOT be logged.",
	loaddkp = "Load DKP",
	loaddkpdesc = "Update DKP from previously created DKP file.",
	twinks = "Add Twink",
	twinksdesc = "Add a player to this raid who is on an alt with DKP under a main.  The mod will remember this.\n Format: <alt> <main>",
	mloot = "Master Looter",
	mlootdesc = "Person assigned to be master looter.  The mod will determine this automatically if it can.",
	denchanter = "Disenchanter",
	denchanterdesc = "Person assigned to be disenchanter.",
	enablemod = "Enable MOD",
	enablemoddesc = "Allows the mod to track DKP and enable loot rolling.",
	enablemlde = "Enable ML/DE mode",
	enablemldedesc = "If ML/DE Mode is on then no loot will be recorded for the master looter or disenchanter defined by the mod.",
	giveboe = "Give BOE",
	giveboedesc = "Give a player in the raid a BOE and record in the raid loot database.",
	Bar_Hint = "L-Click: Announce.\nR-Click: Close tablet.",
	BidWarBar_Hint = "L-Click: Announce & Resend.\nR-Click: Close tablet.",
	raiddbfunc = "Raid Database",
	raiddbfuncdesc = "Add or remove a raid database to track.",
	newdb = "New database",
	newdbdesc = "Create a new raid database for importing DKP (Maximum of 5)\nNote: You must manually edit MorgDKP.pl with the raid name you choose and the website to download data from.",
	deldb = "Delete database",
	deldbdesc = "Delete a raid database. \nNote: You must manually edit MorgDKP.pl and delete the raid name you chose and the website to download data from.",
	classlist = "Classes",
	mvquery = "MorgBid Version Query",
	Bar_Hint_Version = "L-Click: Send tells.\nR-Click: Close tablet.",
	updatemorgbid = "Please update your MorgBid.  http://www3.telus.net/MorgDKP/MorgBid.exe or check in the teamspeak chat window.  Thank-you:)",
	itemhistory = "Item History",
	itemhistorydesc = "Show history of items looted in this raid.  \nNote: Since you last started a new raid.",
	rightclickclose = "Right Click to close.", 
	enablezerosum	= "Enable 0-sum",
	enablezerosumdesc = "Enables the zero sum DKP system.",
	enablebidwar = "Enable BidWar",
	enablebidwardesc = "Enable BidWar mode.  This mode changes the MorgBid query to allow players to bid on items.  Also the MorgDKP tablet uses bids after this NOT member DKP.",
	enablerelationaldkp = "Enable Relational DKP",
	enablerelationaldkpdesc = "Enable RDKP for calculating the earned/spent dkp ratio.",
	lootquery = "Give [%s] to %s, are you sure?",
	actmod = "Please activate the mod to use this function.",
	needraid = "You can not use this function out of a raid group.",
	validname = "You must enter a valid name.",
	toomanydb = "You can not have more than 5 raid databases.  Please delete one if you wish to add more.",
	editpl = "Please edit MorgDKP.pl to look like this:",
	commentout = "Note: Don't forget to comment out the lines you don't need.",
	dbremove = "Removed raid database ",
	noitem = "Item does not exist!",
	nolootrec = "ML Mode is currently on so no loot will be recorded for ML/DE.",
	twinkaltmain = "You must format the string correctly:  <twinkalt> <twinkmain>",
	transfer = "Transferred ",
	dkpp = " DKP Points:  ",
	to = " to ",
	addnewchar = "Added new character ",
	charpoints = "You must format the string correctly:  <character> <points>",
	add = "Added ",
	sub = "Subtracted ",
	olddkp = ": Old DKP: ",
	newdkp = " New DKP: ",
	notexi = " does not exist.",
	dkpstand = "DKP Standings for ",
	receive = " Receives ",
	pointsto = " points each to ",
	attend = " attendees.",
	needpromo = "You must be promoted to send queries.",
	noquery = "Either no classes are selected or no members need this item.",
	querysent = "MorgBid query sent: ",
	doresult = "Results for: ",
	roundbid = "Bids for this round:",
	enterinstance = "You must be in the instance before you can begin tracking DKP.",
	raidstartadd = " attendees to raid start.",
	noraid = "No current raid exists.",
	removed = "Removed ",
	raidatt = " raid attendees.",
	bosskill = " killed at ",
	attadded = " attendees added.",
	leftraid = " left the raid at ",
	joinraid = " joined the raid at ",
	updatedkp = "Updating DKP Points..",
	aliasadd = "Added alias: ",
	playfrom = " players from ",
	nomain = "This main character does not exhist.  No changes made.",
	pet = "PET",
	
	MORGTRACK_DEATH_HOSTILE = "(.-)% dies.",
	MORGTRACKER_MAJORDOMO_YELL = "Impossible! Stay your attack, mortals... I submit! I submit!",
	MorgTracker_lang_LeftGroup = "([^%s]+) has left the raid group",
	MorgTracker_lang_JoinedGroup = "([^%s]+) has joined the raid group",
	MorgTracker_lang_RaidGroup   = "raid group",
	MORGTRACKER_LOOT_RECEIVES1        = "([^%s]+) receives loot: (.+)%.",
	MORGTRACKER_LOOT_RECEIVES1_COUNT	= "([^%s]+) receives loot: (|c%x+|Hitem:%d+:%d+:%d+:%d+|h%[.-%]|h|r)x(%d+)%.",
  	MORGTRACKER_LOOT_RECEIVES2        = "You receive loot: (.+)%.",
	MORGTRACKER_LOOT_RECEIVES2_COUNT	= "You receive loot: (|c%x+|Hitem:%d+:%d+:%d+:%d+|h%[.-%]|h|r)x(%d+)%.",
	MORGTRACKER_MASTERLOOT = "([^%s]+) is now the loot master",
	
	classcount = {
		["PALADIN"] = 8,
		["WARLOCK"] = 6, 
		["MAGE"] = 13, 
		["DRUID"] = 13, 
		["WARRIOR"] = 7, 
		["HUNTER"] = 9, 
		["PRIEST"] = 11, 
		["ROGUE"] = 11, 
		["SHAMAN"] = 4, 
		["NEED"] = 10, 
		["TAKE"] = 11, 
		["PASS"] = 11, 
		["PENDING"] = 2
},
	
	slots = {
		["INVTYPE_HEAD"] = "Head",
		["INVTYPE_NECK"] = "Neck",
		["INVTYPE_SHOULDER"] = "Shoulder",
		["INVTYPE_BODY"] = "Chest",
		["INVTYPE_CHEST"] = "Chest",
		["INVTYPE_WAIST"] = "Waist",
		["INVTYPE_LEGS"] = "Legs",
		["INVTYPE_FEET"] = "Feet",
		["INVTYPE_WRIST"] = "Wrist",
		["INVTYPE_HAND"] = "Hands",
		["INVTYPE_FINGER"] = "Finger",
		["INVTYPE_TRINKET"] = "Trinket",
		["INVTYPE_WEAPON"] = "Weapon",
		["INVTYPE_SHIELD"] = "Weapon",
		["INVTYPE_RANGED"] = "Ranged",
		["INVTYPE_CLOAK"] = "Back",
		["INVTYPE_2HWEAPON"] = "Weapon",
		["INVTYPE_ROBE"] = "Chest",
		["INVTYPE_WEAPONMAINHAND"] = "Weapon",
		["INVTYPE_WEAPONOFFHAND"] = "Weapon",
		["INVTYPE_RANGEDRIGHT"] = "Ranged"	
},

scanslots = {
		["HeadSlot"] = "Head",
		["NeckSlot"] = "Neck",
		["ShoulderSlot"] = "Shoulder",
		["BackSlot"] = "Back",
		["ChestSlot"] = "Chest",
		["WristSlot"] = "Wrist",
		["HandsSlot"] = "Hands",
		["WaistSlot"] = "Waist",
		["LegsSlot"] = "Legs", 
		["FeetSlot"] = "Feet",
		["Finger0Slot"] = "Finger",
		["Finger1Slot"] = "Finger",
		["Trinket0Slot"] = "Trinket", 
		["Trinket1Slot"] = "Trinket",
		["MainHandSlot"] = "Weapon",
		["SecondaryHandSlot"] = "Weapon",
		["RangedSlot"] = "Ranged"
}, 
	
MorgTracker_ZoneTriggers = {
	["Molten Core"] = "Molten Core",
	["Blackwing Lair"] = "Blackwing Lair",
	["Zul'Gurub"] = "Zul'Gurub",
	["Onyxia's Lair"] = "Onyxia's Lair",
	["Ruins of Ahn'Qiraj"] = "Ahn'Qiraj Ruins",
	["Ahn'Qiraj"] = "Ahn'Qiraj Temple",
	["Naxxramas"] = "Naxxramas",
},

MorgTracker_BossUnitTriggers = {
	["Lucifron"] = "Lucifron",
	["Magmadar"] = "Magmadar",
	["Gehennas"] = "Gehennas",
	["Garr"] = "Garr",
	["Baron Geddon"] = "Baron Geddon",
	["Shazzrah"] = "Shazzrah",
	["Sulfuron Harbinger"] = "Sulfuron Harbinger",
	["Golemagg the Incinerator"] = "Golemagg the Incinerator",
	["Majordomo Executus"] = "Majordomo Executus",
	["Ragnaros"] = "Ragnaros",
	["Core Hound"] = "IGNORE",
	["Firesworn"] = "IGNORE",
	["Core Rager"] = "IGNORE",
	["Flamewaker Healer"] = "IGNORE",
	["Flamewaker Elite"] = "IGNORE",
	["Son of Flame"] = "IGNORE",
	
	["Razorgore the Untamed"] = "Razorgore the Untamed",
	["Vaelastrasz the Corrupt"] = "Vaelastrasz the Corrupt",
	["Broodlord Lashlayer"] = "Broodlord Lashlayer",
	["Firemaw"] = "Firemaw",
	["Ebonroc"] = "Ebonroc",
	["Flamegor"] = "Flamegor",
	["Chromaggus"] = "Chromaggus",
	["Nefarian"] = "Nefarian",
	["Lord Victor Nefarius"] = "Nefarian",
	["Grethok the Controller"] = "IGNORE",
	["Blackwing Guardsman"] = "IGNORE",
	["Blackwing Legionnaire"] = "IGNORE",
	["Blackwing Mage"] = "IGNORE",
	["Death Talon Dragonspawn"] = "IGNORE",
	["Black Drakonid"] = "IGNORE",
	["Blue Drakonid"] = "IGNORE",
	["Bronze Drakonid"] = "IGNORE",
	["Green Drakonid"] = "IGNORE",
	["Red Drakonid"] = "IGNORE",
	["Chromatic Drakonid"] = "IGNORE",
	["Bone Construct"] = "IGNORE",
	["Corrupted Infernal"] = "IGNORE",
	["Corrupted Blue Whelp"] = "IGNORE",
	["Corrupted Red Whelp"] = "IGNORE",
	["Corrupted Green Whelp"] = "IGNORE",
	["Corrupted Bronze Whelp"] = "IGNORE",
	["Death Talon Hatcher"] = "IGNORE",
	["Blackwing Taskmaster"] = "IGNORE",
	
	["High Priestess Jeklik"] = "High Priestess Jeklik",
	["High Priest Venoxis"] =	"High Priest Venoxis",
	["High Priestess Mar'li"] =	"High Priestess Mar'li",
	["High Priest Thekal"] = "High Priest Thekal",
	["High Priestess Arlokk"] =	"High Priestess Arlokk",
	["Hakkar"] = "Hakkar",
	["Bloodlord Mandokir"] = "Bloodlord Mandokir",
	["Jin'do the Hexxer"] = "Jin'do the Hexxer",
	["Gahz'ranka"] = "Gahz'ranka",
	["Hazza'rah"] = "Hazza'rah",
	["Gri'lek"] = "Gri'lek",
	["Renataki"] = "Renataki",
	["Wushoolay"] = "Wushoolay",
	["Zulian Prowler"] = "IGNORE",
	["Zulian Guardian"] = "IGNORE",
	["Parasitic Serpent"] = "IGNORE",
	["Spawn of Mar'li"] = "IGNORE",
	["Ohgan"] = "IGNORE",
	["Frenzied Bloodseeker Bat"] = "IGNORE",
	["Poisonous Cloud"] = "IGNORE",
	
	["Onyxia"] = "Onyxia",
	["Lord Kazzak"] = "Lord Kazzak",
	["Azuregos"] = "Azuregos",
	["Ysondre"] = "Ysondre",
	["Taerar"] = "Taerar",
	["Emeriss"] = "Emeriss",
	["Lethon"] = "Lethon",
	
	["Onyxian Whelp"] = "IGNORE",
	["Onyxian Warder"] = "IGNORE",
	["Shade of Taerar"] = "IGNORE",
	["Spirit Shade"] = "IGNORE",
	["Demented Druid Spirit"] = "IGNORE",
	
	["Kurinnaxx"] = "Kurinnaxx",
	["General Rajaxx"] = "General Rajaxx",
	["Ayamiss the Hunter"] = "Ayamiss the Hunter",
	["Buru the Gorger"] = "Buru The Gorger",
	["Moam"] = "Moam",
	["Ossirian the Unscarred"] = "Ossirian The Unscarred",
	["Buru Egg"] = "IGNORE",
	["Canal Frenzy"] = "IGNORE",
	["Mana Fiend"] = "IGNORE",
	["Silicate Feeder"] = "IGNORE",
	["Hive'Zara Hatchling"] = "IGNORE",
	["Hive'Zara Larva"] = "IGNORE",
	["Vekniss Hatchling"] = "IGNORE",
	["Anubisath Warrior"] = "IGNORE",
	
	["The Prophet Skeram"] = "The Prophet Skeram",
	["Fankriss the Unyielding"] = "Fankriss the Unyielding",
	["Battleguard Sartura"] = "Battleguard Sartura",
	["Princess Huhuran"] = "Princess Huhuran",
	["Emperor Vek'lor"] = "Twin Emperors",
	["Emperor Vek'nilash"] = "Twin Emperors",
	["C'Thun"] = "C'Thun",
	["Vem"] = "Vem",
	["Princess Yauj"] = "Princess Yauj",
	["Lord Kri"] = "Lord Kri",
	["Viscidus"] = "Viscidus",
	["Ouro"] = "Ouro",
	["Ouro Scarab"] = "IGNORE",
	["Spawn of Fankriss"] = "IGNORE",
	["Qiraji Scorpion"] = "IGNORE",
	["Qiraji Scarab"] = "IGNORE",
	["Vile Scarab"] = "IGNORE",
	["Yauj Brood"] = "IGNORE",
	["Sartura's Royal Guard"] = "IGNORE",
	["Sartura's Royal Guard"] = "IGNORE",
	["Poison Cloud"] = "IGNORE",
	["Vekniss Drone"] = "IGNORE",
	["Glob of Viscidus"] = "IGNORE",
	
	["Patchwerk"] = "Patchwerk",
	["Grobbulus"] = "Grobbulus",
	["Gluth"] = "Gluth",
	["Thaddius"] = "Thaddius",
	["Instructor Razuvious"] = "Instructor Razuvious",
	["Gothik the Harvester"] = "Gothik the Harvester",
	["Highlord Mograine"] = "Highlord Mograine",
	["Thane Korth'azz"] = "Thane Korth'azz",
	["Lady Blaumeux"] = "Lady Blaumeux",
	["Sir Zeliek"] = "Sir Zeliek",
	["Noth The Plaguebringer"] = "Noth The Plaguebringer",
	["Heigan the Unclean"] = "Heigan the Unclean",
	["Loatheb"] = "Loatheb",
	["Anub'Rekhan"] = "Anub'Rekhan",
	["Grand Widow Faerlina"] = "Grand Widow Faerlina",
	["Maexxna"] = "Maexxna",
	["Sapphiron"] = "Sapphiron",
	["Kel'Thuzad"] = "Kel'Thuzad",

		["Fangnetz"] = "IGNORE",
		["Verstrahlter Br\195\188hschleimer"] = "IGNORE",
		
	["Crypt Guard"] = "IGNORE",
	["Grobbulus Cloud"] = "IGNORE",
	["Deathknight Understudy"] = "IGNORE",
	["Maggot"] = "IGNORE",
	["Maexxna Spiderling"] = "IGNORE",
	["Plagued Warrior"] = "IGNORE",
	["Zombie Chow"] = "IGNORE",
	["Corpse Scarab"] = "IGNORE",
	["Naxxramas Follower"] = "IGNORE",
	["Naxxramas Worshipper"] = "IGNORE",
	["Web Wrap"] = "IGNORE",
	["Fallout Slime"] = "IGNORE",
	["Diseased Maggot"] = "IGNORE",
	["Rotting Maggot"] = "IGNORE",
	["Living Poison"] = "IGNORE",
	["Spore"] = "IGNORE",
	
	["Spotlight"] = "IGNORE",
	["Roach"] = "IGNORE",
	["Snake"] = "IGNORE",
	["Brown Snake"] = "IGNORE",
	["Crimson Snake"] = "IGNORE",
	["Black Kingsnake"] = "IGNORE",
	["Beetle"] = "IGNORE",
	["Dupe Bug"] = "IGNORE",
	["Fire Beetle"] = "IGNORE",
	["Scorpion"] = "IGNORE",
	["Frog"] = "IGNORE",
	["Hooktooth Frenzy"] = "IGNORE",
	["Sacrificed Troll"] = "IGNORE",
	["Spider"] = "IGNORE",
	["Rat"] = "IGNORE",
	["Jungle Toad"] = "IGNORE",
	["Field Repair Bot 74A"] = "IGNORE",
	
	["DEFAULTBOSS"] = "Trash mob",
},
} end)
